=== src/os_dns/Makefile ===
all:
	cc -I.. -I../headers -I/usr/local/include -c os_dns.c ../shared/debug_op.c ../shared/privsep_op.c

clean:
	rm -f *.core *.o
