=== contrib/debian-packages/ossec-hids-agent/debian/changelog ===
ossec-hids-agent (2.8.2-2) unstable; urgency=low

  * Set ossec user home to /var/ossec/
  * Added linux-libc-dev build dependency to Debian control file

 -- Santiago Bassett <santiago.bassett@gmail.com>  Mon, 15 Jun 2015 08:43:10 +0000

ossec-hids-agent (2.8.2-1) unstable; urgency=low

  * 2.8.2 Initial release. Includes several fixes, and patch for CVE-2015-3222

 -- Santiago Bassett <santiago.bassett@gmail.com>  Mon, 15 Jun 2015 08:43:10 +0000
